Index: trunk/LMDZ.PLUTO/libf/phypluto/generic_tracer_index_mod.F90
===================================================================
--- trunk/LMDZ.PLUTO/libf/phypluto/generic_tracer_index_mod.F90	(revision 3258)
+++ trunk/LMDZ.PLUTO/libf/phypluto/generic_tracer_index_mod.F90	(revision 3275)
@@ -6,6 +6,6 @@
 !     for both the vap & ice parts of the tracer
 !
-!     call_ice_vap_generic is a boolean which tells if the tracer is condensable
-!     and allows, if it is condensable, to call the vap/ice pair 
+!     call_ice_gas_generic is a boolean which tells if the tracer is condensable
+!     and allows, if it is condensable, to call the vap/ice pair
 !
 !     Noé Clément & Lucas Teinturier (2022)
@@ -17,15 +17,15 @@
     contains
 
-    subroutine generic_tracer_index(nq,iq,igcm_generic_vap,igcm_generic_ice,call_ice_vap_generic)
+    subroutine generic_tracer_index(nq,iq,igcm_generic_gas,igcm_generic_ice,call_ice_gas_generic)
 
         USE tracer_h, only: noms, is_condensable
-        integer nq,iq, igcm_generic_vap, igcm_generic_ice, i_shortname, ii
-        logical call_ice_vap_generic
+        integer nq,iq, igcm_generic_gas, igcm_generic_ice, i_shortname, ii
+        logical call_ice_gas_generic
         character(len=10) :: shortname
-        if((is_condensable(iq)==1) .and. (index(noms(iq),"vap") .ne. 0) &
+        if((is_condensable(iq)==1) .and. (index(noms(iq),"gas") .ne. 0) &
                                                     .and. (index(noms(iq),"h2o") .eq. 0) .and. (index(noms(iq),"n2") .eq. 0)) then
-            ! Let's get the index of our tracers (we look for igcm _generic_vap and igcm_generic_ice)
+            ! Let's get the index of our tracers (we look for igcm _generic_gas and igcm_generic_ice)
 
-            igcm_generic_vap = iq
+            igcm_generic_gas = iq
             igcm_generic_ice = -1
 
@@ -46,5 +46,5 @@
             ! ! endif
 
-            ! ! call_ice_vap_generic = .true.
+            ! ! call_ice_gas_generic = .true.
             i_shortname = index(noms(iq),'_')-1
             shortname=noms(iq)(1:i_shortname)
@@ -59,7 +59,7 @@
             endif
             ! if we didn't find it before, we look after the vap tracer in pq
-            if (igcm_generic_ice .eq. -1 .and. (iq<nq)) then 
+            if (igcm_generic_ice .eq. -1 .and. (iq<nq)) then
                 do ii=iq+1,nq
-                    if (index(noms(ii),adjustl(trim(shortname))) .ne. 0) then 
+                    if (index(noms(ii),adjustl(trim(shortname))) .ne. 0) then
                         igcm_generic_ice=ii
                         exit
@@ -67,8 +67,8 @@
                 enddo
             endif
-            call_ice_vap_generic = .true.
+            call_ice_gas_generic = .true.
         else
 
-            call_ice_vap_generic = .false.
+            call_ice_gas_generic = .false.
 
         end if ! if((is_condensable(iq)==1) .and. (index(noms(iq),"vap") .ne. 0))
Index: trunk/LMDZ.PLUTO/libf/phypluto/inifis_mod.F90
===================================================================
--- trunk/LMDZ.PLUTO/libf/phypluto/inifis_mod.F90	(revision 3258)
+++ trunk/LMDZ.PLUTO/libf/phypluto/inifis_mod.F90	(revision 3275)
@@ -883,4 +883,23 @@
       " albmin_ch4 = ",albmin_ch4
 
+
+     if (is_master)write(*,*)trim(rname)//&
+     "fixed gaseous CH4 mixing ratio for rad transfer ?"
+     ch4fix=.false. ! default value
+     call getin_p("ch4fix",ch4fix)
+     if (is_master)write(*,*)trim(rname)//&
+       " ch4fix = ",ch4fix
+     if (is_master)write(*,*)trim(rname)//&
+       "fixed gaseous CH4 mixing ratio for rad transfer ?"
+     vmrch4fix=0.5 ! default value
+     call getin_p("vmrch4fix",vmrch4fix)
+     if (is_master)write(*,*)trim(rname)//&
+        " vmrch4fix = ",vmrch4fix
+     vmrch4_proffix=.false. ! default value
+     call getin_p("vmrch4_proffix",vmrch4_proffix)
+     if (is_master)write(*,*)trim(rname)//&
+        " vmrch4_proffix = ",vmrch4_proffix
+
+
 !*********** CO *********************************
 
Index: trunk/LMDZ.PLUTO/libf/phypluto/initracer.F90
===================================================================
--- trunk/LMDZ.PLUTO/libf/phypluto/initracer.F90	(revision 3258)
+++ trunk/LMDZ.PLUTO/libf/phypluto/initracer.F90	(revision 3275)
@@ -127,5 +127,5 @@
        IF (.NOT. allocated(is_rgcs)) allocate(is_rgcs(nq)) !LT
        IF (.NOT. allocated(constants_mass)) allocate(constants_mass(nq))
-       IF (.NOT. allocated(constants_delta_vapH)) allocate(constants_delta_vapH(nq))
+       IF (.NOT. allocated(constants_delta_gasH)) allocate(constants_delta_gasH(nq))
        IF (.NOT. allocated(constants_Tref)) allocate(constants_Tref(nq))
        IF (.NOT. allocated(constants_Pref)) allocate(constants_Pref(nq))
@@ -157,5 +157,5 @@
        is_rgcs(:) = 0
        constants_mass(:)=0
-       constants_delta_vapH(:)=0
+       constants_delta_gasH(:)=0
        constants_Tref(:)=0
        constants_Pref(:)=0
@@ -229,5 +229,5 @@
           write(*,*) 'Tracer ',count,' = n2'
         endif
-        if (noms(iq).eq."ch4_vap") then
+        if (noms(iq).eq."ch4_gas") then
           igcm_ch4_gas=iq
           mmol(igcm_ch4_gas)=16.
@@ -243,5 +243,5 @@
           write(*,*) 'Tracer ',count,' = ch4 ice'
         endif
-        if (noms(iq).eq."co_vap") then
+        if (noms(iq).eq."co_gas") then
           igcm_co_gas=iq
           mmol(igcm_co_gas)=28.
@@ -376,5 +376,5 @@
                 call specie_parameters_table(noms(iq)(1:len(trim(noms(iq)))-4))
                 constants_mass(iq)=m
-                constants_delta_vapH(iq)=delta_vapH
+                constants_delta_gasH(iq)=delta_gasH
                 constants_Tref(iq)=Tref
                 constants_Pref(iq)=Pref
Index: trunk/LMDZ.PLUTO/libf/phypluto/mass_redistribution_mod.F90
===================================================================
--- trunk/LMDZ.PLUTO/libf/phypluto/mass_redistribution_mod.F90	(revision 3258)
+++ trunk/LMDZ.PLUTO/libf/phypluto/mass_redistribution_mod.F90	(revision 3275)
@@ -7,9 +7,9 @@
 		       pu,pv,pdt,pdtsrf,pdq,pdu,pdv,pdmassmr,  &
 		       pdtmr,pdtsrfmr,pdpsrfmr,pdumr,pdvmr,pdqmr,pdqsmr)
-                                                   
+
        use radcommon_h, only: glat
        USE planete_mod, only: bp
        use comcstfi_mod, only: g
-       
+
        IMPLICIT NONE
 !=======================================================================
@@ -22,11 +22,11 @@
 !
 !   input:
-!   ----- 
+!   -----
 !    ngrid                 nombre de points de verticales
 !                          (toutes les boucles de la physique sont au
 !                          moins vectorisees sur ngrid)
 !    nlayer                nombre de couches
-!    pplay(ngrid,nlayer)   Pressure levels 
-!    pplev(ngrid,nlayer+1) Pressure levels 
+!    pplay(ngrid,nlayer)   Pressure levels
+!    pplev(ngrid,nlayer+1) Pressure levels
 !    nq                    Number of tracers
 !
@@ -35,5 +35,5 @@
 !    pu,pv (ngrid,nlayer)  wind velocity (m/s)
 !
-!                    
+!
 !    pdX                   physical tendency of X before mass redistribution
 !
@@ -45,5 +45,5 @@
 !    pdXmr(ngrid)           physical tendency of X after mass redistribution
 !
-!    
+!
 !
 !=======================================================================
@@ -55,5 +55,5 @@
 !    Arguments :
 !    ---------
-      INTEGER,INTENT(IN) :: ngrid, nlayer, nq   
+      INTEGER,INTENT(IN) :: ngrid, nlayer, nq
       REAL,INTENT(IN) :: ptimestep
       REAL,INTENT(IN) :: pcapcal(ngrid)
@@ -80,5 +80,5 @@
       REAL zzu(nlayer),zzv(nlayer)
       REAL zzq(nlayer,nq),zzt(nlayer)
-!    Dummy variables      
+!    Dummy variables
       INTEGER n,l,ig,iq
       REAL zdtsig(ngrid,nlayer)
@@ -88,5 +88,5 @@
       REAL zq1(nlayer)
       REAL ztsrf(ngrid)
-      REAL ztm(nlayer+1) 
+      REAL ztm(nlayer+1)
       REAL zum(nlayer+1) , zvm(nlayer+1)
       REAL zqm(nlayer+1,nq),zqm1(nlayer+1)
@@ -103,11 +103,11 @@
 !
       IF (firstcall) THEN
-         firstcall=.false.	 
+         firstcall=.false.
       ENDIF
 !
 !======================================================================
-!    Calcul of h2o condensation  
+!    Calcul of h2o condensation
 !    ============================================================
-!  
+!
 !    Used variable :
 !       pdmassmr      : air Mass added to the atmosphere in each layer per unit time (kg/m2/s)
@@ -135,5 +135,8 @@
 !    Changing pressure at the surface:
 !    """"""""""""""""""""""""""""""""""""
-         
+
+      zmassboil(1:ngrid) = 0 ! AF: TODO: update this for pluto
+      pdtsrfmr(1:ngrid) = 0
+
       pdpsrfmr(1:ngrid) = (zdmass_sum(1:ngrid,1)+zmassboil(1:ngrid))*g
 
@@ -151,5 +154,5 @@
 
 ! ***************************************************************
-!  Correction to account for redistribution between sigma or hybrid 
+!  Correction to account for redistribution between sigma or hybrid
 !  layers when changing surface pressure
 !  zzx quantities have dimension (nlayer) to speed up calculation
@@ -174,10 +177,10 @@
            ! Ehouarn: but for now leave things as before
             zmflux(l+1) = zmflux(l) + pdmassmr(ig,l) - (bp(l)-bp(l+1))*(zdmass_sum(ig,1)+zmflux(1))
-! zmflux set to 0 if very low to avoid: top layer is disappearing in v1ld  
+! zmflux set to 0 if very low to avoid: top layer is disappearing in v1ld
             if (abs(zmflux(l+1)).lt.1E-13.OR.bp(l+1).eq.0.) zmflux(l+1)=0.
          END DO
 
 ! Mass of each layer
-! ------------------ 
+! ------------------
          zzmass(1:nlayer)=zmass(ig,1:nlayer)*(1.+pdpsrfmr(ig)*ptimestep/pplev(ig,1))
 
@@ -186,19 +189,19 @@
 !  """"""""""""""""""""""""""""""""
 
-!        averaging operator for TRANSPORT  
+!        averaging operator for TRANSPORT
 !        """"""""""""""""""""""""""""""""
 !        Value transfert at the surface interface when condensation
 !        sublimation:
          ztm(1) = ztsrf(ig)
-         zum(1) = 0.  
-         zvm(1) = 0.  
+         zum(1) = 0.
+         zvm(1) = 0.
          zqm(1,1:nq)=0. ! most tracer do not condense !
-         !! if (water) zqm(1,igcm_h2o_vap)=1. ! flux is 100% h2o at surface
-	 
+         !! if (water) zqm(1,igcm_h2o_gas)=1. ! flux is 100% h2o at surface
+
 !        Van Leer scheme:
          w(1:nlayer+1)=-zmflux(1:nlayer+1)*ptimestep
-         call vl1d(nlayer,zzt,2.,zzmass,w,ztm) 
-         call vl1d(nlayer,zzu,2.,zzmass,w,zum) 
-         call vl1d(nlayer,zzv,2.,zzmass,w,zvm) 
+         call vl1d(nlayer,zzt,2.,zzmass,w,ztm)
+         call vl1d(nlayer,zzu,2.,zzmass,w,zum)
+         call vl1d(nlayer,zzv,2.,zzmass,w,zvm)
          do iq=1,nq
            zq1(1:nlayer)=zzq(1:nlayer,iq)
@@ -214,5 +217,5 @@
 
 !        Surface condensation affects low winds
-         if (zmflux(1).lt.0) then 
+         if (zmflux(1).lt.0) then
             zum(1)= zzu(1) *  (w(1)/zzmass(1))
             zvm(1)= zzv(1) *  (w(1)/zzmass(1))
@@ -222,14 +225,14 @@
             end if
          end if
-                    
-         ztm(nlayer+1)= zzt(nlayer) ! should not be used, but... 
+
+         ztm(nlayer+1)= zzt(nlayer) ! should not be used, but...
          zum(nlayer+1)= zzu(nlayer)  ! should not be used, but...
          zvm(nlayer+1)= zzv(nlayer)  ! should not be used, but...
          zqm(nlayer+1,1:nq)= zzq(nlayer,1:nq)
- 
-!        Tendencies on T, U, V, Q 
+
+!        Tendencies on T, U, V, Q
 !        """"""""""""""""""""""""
          DO l=1,nlayer
- 
+
 !           Tendencies on T
             pdtmr(ig,l) = (1/zzmass(l)) *   &
@@ -253,5 +256,5 @@
          enddo
 
-      END DO  ! loop on ig 
+      END DO  ! loop on ig
 
 CONTAINS
@@ -260,5 +263,5 @@
       SUBROUTINE vl1d(llm,q,pente_max,zzmass,w,qm)
 !
-!    
+!
 !     Operateur de moyenne inter-couche pour calcul de transport type
 !     Van-Leer " pseudo amont " dans la verticale
@@ -270,5 +273,5 @@
 !
 !   --------------------------------------------------------------------
-      
+
       IMPLICIT NONE
 
@@ -280,5 +283,5 @@
       REAL w(llm+1)
 !
-!      Local 
+!      Local
 !   ---------
 !
@@ -287,9 +290,9 @@
       real dzq(llm),dzqw(llm),adzqw(llm),dzqmax
       real sigw, Mtot, MQtot
-      integer m 
-!     integer ismax,ismin 
-
-
-!    On oriente tout dans le sens de la pression 
+      integer m
+!     integer ismax,ismin
+
+
+!    On oriente tout dans le sens de la pression
 !     W > 0 WHEN DOWN !!!!!!!!!!!!!
 
@@ -347,6 +350,6 @@
                stop
              end if
-          else      ! if(w(l+1).lt.0) 
-             m = l-1 
+          else      ! if(w(l+1).lt.0)
+             m = l-1
              Mtot = zzmass(m+1)
              MQtot = zzmass(m+1)*q(m+1)
@@ -365,5 +368,5 @@
              else
                 qm(l+1)= (-1/w(l+1))*(MQtot + (-w(l+1)-Mtot)*qm(1))
-             end if   
+             end if
           end if
        enddo
@@ -373,5 +376,5 @@
 !         if(w(1).gt.0.) then
 !            qm(1)=q(1)
-!         else 
+!         else
 !           qm(1)=0.
 !         end if
Index: trunk/LMDZ.PLUTO/libf/phypluto/nlte_ch4.F90
===================================================================
--- trunk/LMDZ.PLUTO/libf/phypluto/nlte_ch4.F90	(revision 3275)
+++ trunk/LMDZ.PLUTO/libf/phypluto/nlte_ch4.F90	(revision 3275)
@@ -0,0 +1,304 @@
+      subroutine nlte_ch4(ngrid,nlayer,nq,pplay,pplev,pt,vmrch4,eps23,eps33,eps76)
+
+      use comgeomfi_h
+      use callkeys_mod, only: strobel
+      use tracer_h, only: igcm_n2,mmol
+      use comcstfi_mod, only: pi, g, cpp,r
+      implicit none
+
+!==================================================================
+!     Purpose
+!     -------
+!     Calculation of epsilon - non LTE efficiency factor
+!     For CH4 heating and cooling rate calculation
+!     Cf Strobel et al 1996
+!
+!     Inputs
+!     ------
+!     ngrid                 Number of vertical columns
+!     nlayer                Number of layers
+!     pplay(ngrid,nlayer)   Pressure layers
+!     pt
+!
+!     Outputs
+!     -------
+!
+!     eps_sw       ! efficiency factor for heating rate
+!     eps_lw       ! efficiency factor for cooling rate
+!
+!     Authors
+!     -------
+!     Tanguy Bertrand (2015,2022)
+!
+!==================================================================
+
+!-----------------------------------------------------------------------
+
+!     Arguments
+
+      INTEGER ngrid, nlayer, nq
+      REAL pplay(ngrid,nlayer)
+      REAL pplev(ngrid,nlayer)
+      REAL pt(ngrid,nlayer)
+      REAL vmrch4(ngrid,nlayer)
+
+!-----------------------------------------------------------------------
+!     Local variables
+
+      INTEGER l,ig
+
+      REAL cbol         ! Boltzman constant
+      REAL avog         ! avogadro constant
+      REAL beta23
+      REAL beta33
+      REAL nd(ngrid,nlayer)      ! density number  cm-3
+      REAL na(ngrid,nlayer)      ! column density number  cm-2
+      REAL rho(ngrid,nlayer)     ! density of atmosphere
+      REAL kn3,k3,k2n4,k3n4,k4
+      REAL An3,A3,A2n4,A3n4,A4
+      REAL dphin3,dphi3,dphi2n4,dphi3n4,dphi4
+      REAL phin3(ngrid,nlayer)
+      REAL phi3(ngrid,nlayer)
+      REAL phi2n4(ngrid,nlayer)
+      REAL phi3n4(ngrid,nlayer)
+      REAL phi4(ngrid,nlayer)
+      REAL phi4T(ngrid,nlayer)
+
+!     DATA from Strobel et al 1996
+      REAL, DIMENSION(22) :: gam2       ! band escape fonction 2.3
+      REAL, DIMENSION(22) :: Naval2     ! column density number 2.3
+      REAL, DIMENSION(22) :: gam3       ! band escape fonction 3.3
+      REAL, DIMENSION(22) :: Naval3    ! column density number 3.3
+      REAL gammafi23(nlayer),gammafi33(nlayer)       ! Band espace fonction
+      REAL gammafi23mod(nlayer),gammafi33mod(nlayer)       ! Band espace fonction
+      REAL vmr
+      REAL k4zT  ! function to calculate k4 depending on T and vmr
+      REAL log_square ! log function
+      REAL log_affine ! log function
+      REAL ratio_affine ! linear approx function to calculate ratio for gamma calculation
+      REAL ratio_square !
+      REAL ratio_sq,ratio_af
+
+!     Output
+      REAL,intent(out) :: eps23(ngrid,nlayer)
+      REAL,intent(out) :: eps33(ngrid,nlayer)
+      REAL,intent(out) :: eps76(ngrid,nlayer)
+
+!     Option simplified coefficient
+      REAL klw, ksw,  eps_sw1Pa
+
+!-----------------------------------------------------------------------
+      eps23(:,:)=1.
+      eps33(:,:)=1.
+      eps76(:,:)=1.
+
+      IF (strobel) then
+
+!       Constantes
+        cbol=1.3806488e-23 !Boltzman constant
+        avog=6.022141e23
+
+        ! band 3
+        k3=2.8e-11    !cm-3
+        A3=25.2
+        dphi3=k3/A3
+        ! band n3
+        kn3=2.8e-11    !cm-3
+        An3=27.3
+        dphin3=kn3/An3
+        ! band 3n4
+        k3n4=1.16e-11  !cm-3
+        A3n4=2.12
+        dphi3n4=k3n4/(3.*A3n4)
+        ! band 4
+        !! Here we use function k4zT instead of constant k4
+        k4=4.5e-16        !cm-3
+        A4=2.12
+        dphi4=k4/A4
+        ! band 2n4
+        k2n4=1.16e-11
+        A2n4=2.12
+        dphi2n4=k2n4/(2.*A2n4)
+
+!       2.3 band :
+        beta23=0.09
+!       3.3 band :
+        beta33=0.13
+
+!       Escape Function Gamma (Data Strobel et al) :
+        ! 100 K 2.3
+        Naval2=(/1.00000000e+10,1.30000000e+15,2.92766055e+15,6.59322793e+15,1.48482564e+16,3.34389650e+16, &
+                7.53061067e+16,1.69592860e+17,3.81931020e+17,8.60126447e+17,1.93704482e+18,4.36231516e+18, &
+                9.82413694e+18,2.21244140e+19,4.98252108e+19,1.12208695e+20,2.52699209e+20,5.69090388e+20, &
+                1.28161806e+21,2.88626357e+21,6.50000000e+21,1.00000000e+24/)
+        gam2=(/1.00000000e+00,1.00000000e+00,1.00000000e+00,1.00000000e+00,1.00000000e+00,9.90000000e-01, &
+              9.80000000e-01,9.50000000e-0,9.00000000e-01,8.00000000e-01,7.00000000e-01,5.00000000e-01, &
+              3.50000000e-01,2.20000000e-01,1.20000000e-01,6.50000000e-02,3.20000000e-02,1.40000000e-02, &
+              6.20000000e-03,2.50000000e-03,1.05000000e-03,4.83227951e-06/)
+
+        ! 100 K 3.3
+        Naval3=(/1.00000000e+10,1.30000000e+15,2.92766055e+15,6.59322793e+15,1.48482564e+16,3.34389650e+16, &
+                7.53061067e+16,1.69592860e+17,3.81931020e+17,8.60126447e+17,1.93704482e+18,4.36231516e+18, &
+                9.82413694e+18,2.21244140e+19,4.98252108e+19,1.12208695e+20,2.52699209e+20,5.69090388e+20, &
+                1.28161806e+21,2.88626357e+21,6.50000000e+21,1.00000000e+24/)
+        gam3=(/1.00000000e+00,9.80000000e-01,9.00000000e-01,8.50000000e-01,7.00000000e-01,5.00000000e-01, &
+              3.00000000e-01,1.50000000e-01,1.00000000e-01,6.00000000e-02,4.00000000e-02,2.30000000e-02, &
+              1.45000000e-02,9.00000000e-03,5.00000000e-03,3.00000000e-03,1.50000000e-03,8.00000000e-04, &
+              3.80000000e-04,1.80000000e-04,8.30000000e-05,6.81737544e-07/)
+
+        DO ig=1,ngrid
+
+          phi3n4(ig,:)=1.
+          phi2n4(ig,:)=1.
+          phin3(ig,:)=1.
+          phi4(ig,:)=1.
+          nd(ig,:)=1.
+          na(ig,:)=1.
+
+          !write(*,*) 'TB22 pplev=',pplev(1,:)
+          !write(*,*) 'TB22 tlev=',pt(1,:)
+
+          DO l=1,nlayer
+           !!calculation of density
+           rho(ig,l)=pplay(ig,l)/(r*pt(ig,l))
+
+           !!calculation of column number density for ch4 (cm-2)
+           na(ig,l)=vmrch4(ig,l)/100./(mmol(igcm_n2)*1.e-3)* &
+                             pplev(ig,l)/g*avog*1.e-4
+
+           !!calculation of atmospheric number density (cm-3) for each layer
+           nd(ig,l)=rho(ig,l)/(mmol(igcm_n2)*1.e-3)*avog*1.e-6
+
+           !!calculation of the phi :
+           phin3(ig,l)=dphin3*nd(ig,l)
+           phi3(ig,l)=dphi3*nd(ig,l)
+           phi2n4(ig,l)=dphi2n4*nd(ig,l)
+           phi3n4(ig,l)=dphi3n4*nd(ig,l)
+           phi4(ig,l)=dphi4*nd(ig,l)
+           !! Getting phi4 depending on T and vmr
+           vmr=vmrch4(ig,l)/100.
+           phi4T(ig,l)=k4zT(pt(ig,l),vmr)/A4*nd(ig,l)
+          ENDDO
+          !write(*,*) 'TB22 nd=',nd(1,:)
+          !write(*,*) 'TB22 vmr=',vmrch4
+          !write(*,*) 'TB22 phi4T=',phi4T
+
+          !! interpolation of na values in cm-2 from Strobel values for
+          !the 100K model:
+          CALL interp_line(Naval2,gam2,22,na(ig,:),gammafi23,nlayer)
+          CALL interp_line(Naval3,gam3,22,na(ig,:),gammafi33,nlayer)
+
+          !write(*,*) 'TB22rad na = ',na(1,:)
+          !write(*,*) 'TB22rad gammafi = ',gammafi23
+
+          DO l=1,nlayer
+
+           !! Getting ratio depending on temperature and n (cm-2)
+           ratio_sq=ratio_square(pt(ig,l),na(ig,l))
+           ratio_af=ratio_affine(pt(ig,l),na(ig,l))
+           !! Modified gamma depending on T
+           gammafi23mod(l)=min(ratio_sq*gammafi23(l),1.)
+           gammafi33mod(l)=min(ratio_af*gammafi33(l),1.)
+
+           !! Heating : cf Strobel 1996 and Zalucha 2011
+           ! eps 2.3
+           eps23(ig,l)=phin3(ig,l)/(phin3(ig,l)+gammafi23mod(l))*     &
+                      (beta23+phi3n4(ig,l)/(phi3n4(ig,l)+1)*  &
+                      phi4T(ig,l)/(phi4T(ig,l)+gammafi23mod(l))*   &
+                      (3.*phi2n4(ig,l)+1.)/(1.+phi2n4(ig,l))*(1-beta23)/3.)
+
+           ! eps 3.3
+           eps33(ig,l)=phi3(ig,l)/(phi3(ig,l)+gammafi33mod(l))*     &
+                      (beta33+phi2n4(ig,l)/(phi2n4(ig,l)+1)*  &
+                      phi4T(ig,l)/(phi4T(ig,l)+gammafi33mod(l))*   &
+                      (1-beta33))
+
+           ! Cooling from Zalucha et al 2013 eq10
+           eps76(ig,l)=1./(1.+gammafi23mod(l)/(2.*phi4T(ig,l)))
+
+          ENDDO
+          !write(*,*) 'TB22rad eps23 = ',eps23(1,:)
+          !write(*,*) 'TB22rad eps33 = ',eps33(1,:)
+          !write(*,*) 'TB22rad gamma33 = ',gammafi33mod
+          !write(*,*) 'TB22rad eps76 = ',eps76(1,:)
+
+        ENDDO   ! ngrid
+
+      ELSE     !    if (strobel)
+         !if strobel = false
+
+         klw = 3.6E-4  ! fit strobel
+         !eps_sw1Pa = 0.6 ! fit strobel
+         eps_sw1Pa = 0.90 ! to fit NH temperature en 1D [ch4]=0.5
+         !eps_sw1Pa = 0.98 ! to fit NH temperature en 3D = fit 1D [ch4]=0.25
+
+         ksw = 8.5E-5*(0.9/(eps_sw1Pa-0.1)-1.)
+         do l=1, nlayer
+           do ig=1, ngrid
+              rho(ig,l)=pplay(ig,l)/(r*pt(ig,l))
+              eps23(ig,l) =  0.1+ 0.9/(1.+ksw/rho(ig,l))
+              eps76(ig,l) = 1./(1.+klw/rho(ig,l))
+           end do
+         end do
+
+      END IF
+
+      end subroutine nlte_ch4
+
+      real function k4zT(temp,vmr)
+      implicit none
+      real, intent(in) ::  temp,vmr
+      k4zT=1.9e-15*exp((temp-240.)/70.)*(1+10.*vmr)
+      return
+      end function k4zT
+
+      !! Log log affine and square function for ratio adjustment and extrapolation
+
+      real function log_square(x,y1,y2,x1,x2,coef)
+      implicit none
+      real, intent(in) ::  x,y1,y2,x1,x2,coef
+      real aa,bb
+      aa=(log(y2)-log(y1))/((log(coef*x2))**4-(log(coef*x1)**4))
+      bb=log(y2)-aa*(log(coef*x2))**4
+      log_square=exp(aa*(log(coef*x))**4+bb)
+      return
+      end function log_square
+
+      real function log_affine(x,y1,y2,x1,x2)
+      real, intent(in) :: x,y1,y2,x1,x2
+      real aa,bb
+      aa=(log(y2)-log(y1))/(log(x2)-log(x1))
+      bb=log(y2)-aa*log(x2)
+      log_affine=exp(aa*log(x)+bb)
+      return
+      end function log_affine
+
+      !! Ratio of gamma depending on T. Linear approximation
+      real function ratio_affine(temp,n)
+      implicit none
+      real, intent(in) :: temp,n
+      real aa,bb,ratio0
+      real log_affine
+      aa=(1.-0.2)/(100.-40.)
+      bb=1.-aa*100.
+      ratio0=aa*temp+bb
+      ratio_affine=log_affine(n,1.,ratio0,1e15,1e22)
+      return
+      end function ratio_affine
+
+      !! Ratio of gamma depending on T. Linear approximation
+      real function ratio_square(temp,n)
+      implicit none
+      real, intent(in) :: temp,n
+      real aa,bb,ratio0,coef
+      real log_square
+      coef=1.e-12
+      aa=(1.-0.2)/(100.-40.)
+      bb=1.-aa*100.
+      ratio0=aa*temp+bb
+      ratio_square=log_square(n,1.,ratio0,1e15,1e22,coef)
+      return
+      end function ratio_square
+
+
+
Index: trunk/LMDZ.PLUTO/libf/phypluto/phyetat0_mod.F90
===================================================================
--- trunk/LMDZ.PLUTO/libf/phypluto/phyetat0_mod.F90	(revision 3258)
+++ trunk/LMDZ.PLUTO/libf/phypluto/phyetat0_mod.F90	(revision 3275)
@@ -257,5 +257,5 @@
 endif ! of if (nq.ge.1)
 
-!!call WriteField_phy("in_phyetat0_qsurf",qsurf(1:ngrid,igcm_h2o_vap),1)
+!!call WriteField_phy("in_phyetat0_qsurf",qsurf(1:ngrid,igcm_h2o_gas),1)
 
 if (startphy_file) then
